using System;
using System.Drawing;
using System.Windows.Forms;
using CP210xExLib;

namespace BaudConfigView
{
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.ComboBox cbDevices;
        private System.Windows.Forms.ListView liBaudConfig;
        private System.Windows.Forms.ColumnHeader BaudGen;
        private System.Windows.Forms.ColumnHeader BaudRate;
        private System.Windows.Forms.ColumnHeader Prescaler;
        private System.Windows.Forms.ColumnHeader Timer0Reload;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			CP210xDevices Devices = new CP210xDevices();

			foreach(CP210x Device in Devices)
			{
			    cbDevices.Items.Add("VID = " + Device.GetDeviceVid() +
			                        ", PID = " + Device.GetDevicePid() +
			                        ", SN = " + Device.GetDeviceSerialNumber());

			    System.Runtime.InteropServices.Marshal.ReleaseComObject(Device);
			}
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		private void InitializeComponent()
		{
            this.cbDevices = new System.Windows.Forms.ComboBox();
            this.liBaudConfig = new System.Windows.Forms.ListView();
            this.BaudGen = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.BaudRate = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.Prescaler = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.Timer0Reload = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.SuspendLayout();
            // 
            // cbDevices
            // 
            this.cbDevices.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.cbDevices.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbDevices.Location = new System.Drawing.Point(16, 224);
            this.cbDevices.Name = "cbDevices";
            this.cbDevices.Size = new System.Drawing.Size(472, 21);
            this.cbDevices.TabIndex = 2;
            this.cbDevices.SelectedIndexChanged += new System.EventHandler(this.cbDevices_SelectedIndexChanged);
            // 
            // liBaudConfig
            // 
            this.liBaudConfig.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.liBaudConfig.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.BaudGen,
            this.BaudRate,
            this.Prescaler,
            this.Timer0Reload});
            this.liBaudConfig.FullRowSelect = true;
            this.liBaudConfig.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.liBaudConfig.Location = new System.Drawing.Point(16, 8);
            this.liBaudConfig.MultiSelect = false;
            this.liBaudConfig.Name = "liBaudConfig";
            this.liBaudConfig.Size = new System.Drawing.Size(472, 200);
            this.liBaudConfig.TabIndex = 3;
            this.liBaudConfig.UseCompatibleStateImageBehavior = false;
            this.liBaudConfig.View = System.Windows.Forms.View.Details;
            // 
            // BaudGen
            // 
            this.BaudGen.Text = "BaudGen";
            this.BaudGen.Width = 112;
            // 
            // BaudRate
            // 
            this.BaudRate.Text = "BaudRate";
            this.BaudRate.Width = 112;
            // 
            // Prescaler
            // 
            this.Prescaler.Text = "Prescaler";
            this.Prescaler.Width = 112;
            // 
            // Timer0Reload
            // 
            this.Timer0Reload.Text = "Timer0Reload";
            this.Timer0Reload.Width = 112;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(504, 261);
            this.Controls.Add(this.liBaudConfig);
            this.Controls.Add(this.cbDevices);
            this.Name = "Form1";
            this.Text = "Form1";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new Form1());
		}

        private void cbDevices_SelectedIndexChanged(object sender, EventArgs e)
        {
            CP210xDevices Devices = new CP210xDevices();
            CP210x Device = (CP210x)Devices[cbDevices.SelectedIndex];

            liBaudConfig.Items.Clear();

            foreach (BaudConfig bc in Device.GetBaudRateConfig())
            {
                liBaudConfig.Items.Add(new ListViewItem(new String[] {  bc.BaudGen.ToString(),
                                                                        bc.BaudRate.ToString(),
                                                                        bc.Prescaler.ToString(),
                                                                        bc.Timer0Reload.ToString()
                                                                     }));
            }

            System.Runtime.InteropServices.Marshal.ReleaseComObject(Device);
            System.Runtime.InteropServices.Marshal.ReleaseComObject(Devices);
        }
	}
}
