#ifndef CP210XEX_H
#define CP210XEX_H

// {0A49C6AF-546F-4381-893E-28CD124966C2}
DEFINE_GUID(LIBID_CP210xExLib,
    0x0A49C6AF, 0x546F, 0x4381, 0x89, 0x3E, 0x28, 0xCD, 0x12, 0x49, 0x66, 0xC2);

// {2FC05A0F-CD36-4A77-A788-C9BC232E947F}
DEFINE_GUID(CLSID_CP210xDevices,
    0x2FC05A0F, 0xCD36, 0x4A77, 0xA7, 0x88, 0xC9, 0xBC, 0x23, 0x2E, 0x94, 0x7F);

// {E0347167-155C-41C3-BDC2-0332A467445A}
DEFINE_GUID(IID_ICP210xDevices,
    0xE0347167, 0x155C, 0x41C3, 0xBD, 0xC2, 0x03, 0x32, 0xA4, 0x67, 0x44, 0x5A);

// {5E6DD2FE-FD99-4B76-9AC7-097B52505EFF}
DEFINE_GUID(CLSID_CP210x,
    0x5E6DD2FE, 0xFD99, 0x4B76, 0x9A, 0xC7, 0x09, 0x7B, 0x52, 0x50, 0x5E, 0xFF);

// {21C0A0DD-48BB-4C18-9191-ADE31858577D}
DEFINE_GUID(IID_ICP210x,
    0x21C0A0DD, 0x48BB, 0x4C18, 0x91, 0x91, 0xAD, 0xE3, 0x18, 0x58, 0x57, 0x7D);

enum Options
{
    SerialNumber = 0,
    Description = 1,
    FullPath = 2
};

enum PartNumbers
{
    CP2101 = 1,
    CP2102 = 2,
    CP2103 = 3,
    CP2104 = 4,
    CP2105 = 5,
    CP2108 = 8,
    CP2109 = 9
};

enum DeviceMode
{
    modeModem = 0,
    modeGpio = 1
};

#include <pshpack4.h>

typedef struct
{
    WORD    BaudGen;
    WORD    Timer0Reload;
    BYTE    Prescaler;
    DWORD   BaudRate;
} BaudConfig;

typedef struct
{
    WORD    Mode;
    WORD    Reset_Latch;
    WORD    Suspend_Latch;
    BYTE    EnhancedFxn;
} PortConfig;

#include <poppack.h>

#undef  INTERFACE
#define INTERFACE  ICP210xDevices
DECLARE_INTERFACE_IID_(ICP210xDevices, IDispatch, "E0347167-155C-41C3-BDC2-0332A467445A")
{
    BEGIN_INTERFACE

    IFACEMETHOD(QueryInterface) (THIS_ REFIID riid, PVOID* ppvObj)PURE;
    IFACEMETHOD_(ULONG, AddRef) (THIS)PURE;
    IFACEMETHOD_(ULONG, Release)(THIS)PURE;

    IFACEMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    IFACEMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    IFACEMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    IFACEMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    IFACEMETHOD(get_Item)(THIS_ const VARIANT varIndex, VARIANT* pVal)PURE;
    IFACEMETHOD(get_Count)(THIS_ long* pVal)PURE;
    IFACEMETHOD(get_length)(THIS_ long* pVal)PURE;
    IFACEMETHOD(get__NewEnum)(THIS_ IUnknown** ppVal)PURE;
    IFACEMETHOD(GetProductString)(THIS_ long nDeviceNum, enum Options nOptions, BSTR* pbstrString)PURE;

    END_INTERFACE
};

#undef  INTERFACE
#define INTERFACE  ICP210x
DECLARE_INTERFACE_IID_(ICP210x, IDispatch, "21C0A0DD-48BB-4C18-9191-ADE31858577D")
{
    BEGIN_INTERFACE

    IFACEMETHOD(QueryInterface) (THIS_ REFIID riid, PVOID* ppvObj)PURE;
    IFACEMETHOD_(ULONG, AddRef) (THIS)PURE;
    IFACEMETHOD_(ULONG, Release)(THIS)PURE;

    IFACEMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    IFACEMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    IFACEMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    IFACEMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    IFACEMETHOD(get_Devices)(THIS_ IDispatch** ppDevices)PURE;
    IFACEMETHOD(GetPartNumber)(THIS_ enum PartNumbers* pPartNum)PURE;
    IFACEMETHOD(SetVid)(THIS_ long VID)PURE;
    IFACEMETHOD(SetPid)(THIS_ long PID)PURE;
    IFACEMETHOD(SetProductString)(THIS_ BSTR strProduct)PURE;
    IFACEMETHOD(SetSerialNumber)(THIS_ BSTR strSerialNumber)PURE;
    IFACEMETHOD(SetSelfPower)(THIS_ VARIANT_BOOL SelfPower)PURE;
    IFACEMETHOD(SetMaxPower)(THIS_ long MaxPower)PURE;
    IFACEMETHOD(SetDeviceVersion)(THIS_ long wVersion)PURE;
    IFACEMETHOD(SetLockValue)(THIS)PURE;
    IFACEMETHOD(GetDeviceProductString)(THIS_ BSTR* ProductString)PURE;
    IFACEMETHOD(GetDeviceSerialNumber)(THIS_ BSTR* SerNum)PURE;
    IFACEMETHOD(GetDeviceVid)(THIS_ long* VID)PURE;
    IFACEMETHOD(GetDevicePid)(THIS_ long* PID)PURE;
    IFACEMETHOD(GetSelfPower)(THIS_ VARIANT_BOOL* SelfPower)PURE;
    IFACEMETHOD(GetMaxPower)(THIS_ long* MaxPower)PURE;
    IFACEMETHOD(GetDeviceVersion)(THIS_ long* wVersion)PURE;
    IFACEMETHOD(GetLockValue)(THIS_ VARIANT_BOOL* LockVal)PURE;
    IFACEMETHOD(Reset)(THIS)PURE;
    IFACEMETHOD(CreateHexFile)(THIS_ BSTR bstrFileName)PURE;
    IFACEMETHOD(GetBaudRateConfig)(THIS_ SAFEARRAY** ppBaudConfig)PURE;
    IFACEMETHOD(SetBaudRateConfig)(THIS_ SAFEARRAY** ppBaudConfig)PURE;
    IFACEMETHOD(GetPortConfig)(THIS_ PortConfig* pConfig)PURE;
    IFACEMETHOD(SetPortConfig)(THIS_ PortConfig* pConfig)PURE;
    IFACEMETHOD(GetFlushBufferConfig)(THIS_ long* pwFlushBufferConfig)PURE;
    IFACEMETHOD(SetFlushBufferConfig)(THIS_ long wFlushBufferConfig)PURE;
    IFACEMETHOD(SetInterfaceString)(THIS_ long InterfaceNumber, BSTR strInterface)PURE;
    IFACEMETHOD(GetDeviceInterfaceString)(THIS_ long InterfaceNumber, BSTR* strInterface)PURE;
    IFACEMETHOD(SetManufacturerString)(THIS_ BSTR strManufacturer)PURE;
    IFACEMETHOD(GetDeviceManufacturerString)(THIS_ BSTR* strManufacturer)PURE;
    IFACEMETHOD(SetDeviceMode)(THIS_ enum DeviceMode ECI, enum DeviceMode SCI)PURE;
    IFACEMETHOD(GetDeviceMode)(THIS_ enum DeviceMode* ECI, enum DeviceMode* SCI)PURE;

    END_INTERFACE
};

#define DISPID_CP210X_ITEM                          0x00000000
#define DISPID_CP210X_COUNT                         0xFFFFFDED
#define DISPID_CP210X_LENGTH                        0xFFFFFDEE
#define DISPID_CP210X__NEWENUM                      0xFFFFFFFC
#define DISPID_CP210X_GETPRODUCTSTRING              0x00000005

#define DISPID_CP210X_DEVICES                       0xFFFFFCDD
#define DISPID_CP210X_GETPARTNUMBER                 0x00000011
#define DISPID_CP210X_SETVID                        0x00000012
#define DISPID_CP210X_SETPID                        0x00000013
#define DISPID_CP210X_SETPRODUCTSTRING              0x00000014
#define DISPID_CP210X_SETSERIALNUMBER               0x00000015
#define DISPID_CP210X_SETSELFPOWER                  0x00000016
#define DISPID_CP210X_SETMAXPOWER                   0x00000017
#define DISPID_CP210X_SETDEVICEVERSION              0x00000018
#define DISPID_CP210X_SETLOCKVALUE                  0x00000019
#define DISPID_CP210X_GETDEVICEPRODUCTSTRING        0x0000001A
#define DISPID_CP210X_GETDEVICESERIALNUMBER         0x0000001B
#define DISPID_CP210X_GETDEVICEVID                  0x0000001C
#define DISPID_CP210X_GETDEVICEPID                  0x0000001D
#define DISPID_CP210X_GETSELFPOWER                  0x0000001E
#define DISPID_CP210X_GETMAXPOWER                   0x0000001F
#define DISPID_CP210X_GETDEVICEVERSION              0x00000020
#define DISPID_CP210X_GETLOCKVALUE                  0x00000021
#define DISPID_CP210X_RESET                         0x00000022
#define DISPID_CP210X_CREATEHEXFILE                 0x00000023
#define DISPID_CP210X_GETBAUDRATECONFIG             0x00000024
#define DISPID_CP210X_SETBAUDRATECONFIG             0x00000025
#define DISPID_CP210X_GETPORTCONFIG                 0x00000026
#define DISPID_CP210X_SETPORTCONFIG                 0x00000027
#define DISPID_CP210X_GETFLUSHBUFFERCONFIG          0x00000028
#define DISPID_CP210X_SETFLUSHBUFFERCONFIG          0x00000029
#define DISPID_CP210X_SETINTERFACESTRING            0x0000002A
#define DISPID_CP210X_GETDEVICEINTERFACESTRING      0x0000002B
#define DISPID_CP210X_SETMANUFACTURERSTRING         0x0000002C
#define DISPID_CP210X_GETDEVICEMANUFACTURERSTRING   0x0000002D
#define DISPID_CP210X_SETDEVICEMODE                 0x0000002E
#define DISPID_CP210X_GETDEVICEMODE                 0x0000002F

#define CP210X_E_DEVICE_IO_FAILED        ((HRESULT)0x80040203L)
#define CP210X_E_GLOBAL_DATA_ERROR       ((HRESULT)0x80040205L)
#define CP210X_E_FILE_ERROR              ((HRESULT)0x80040206L)
#define CP210X_E_COMMAND_FAILED          ((HRESULT)0x80040208L)
#define CP210X_E_INVALID_ACCESS_TYPE     ((HRESULT)0x80040209L)
#define CP210X_E_DEVICE_NOT_FOUND        ((HRESULT)0x800402FFL)

#endif
