#ifndef CCP210XDEVICES_H
#define CCP210XDEVICES_H

class CCP210xDevices : public ICP210xDevices, public IProvideClassInfo, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() noexcept { return(static_cast<ICP210xDevices*>(this)); }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) noexcept { return(::RaiseCOMException(this, dispid, hr)); }

public:
    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IDispatch
    IFACEMETHOD(GetTypeInfoCount)(UINT* pctinfo);
    IFACEMETHOD(GetTypeInfo)(UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    IFACEMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    IFACEMETHOD(Invoke)(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ICP210xDevices
    IFACEMETHOD(get_Item)(const VARIANT varIndex, VARIANT* pVal);
    IFACEMETHOD(get_Count)(long* pVal);
    IFACEMETHOD(get_length)(long* pVal);
    IFACEMETHOD(get__NewEnum)(IUnknown** ppVal);
    IFACEMETHOD(GetProductString)(long nDeviceNum, enum Options nOptions, BSTR* pbstrString);

    // IProvideClassInfo
    IFACEMETHOD(GetClassInfo)(ITypeInfo** ppTI);

    // ISupportErrorInfo
    IFACEMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

    explicit CCP210xDevices(HRESULT* phr);
    virtual ~CCP210xDevices();

private:
    HRESULT getNumDevices(DISPID dispid, long* pVal) noexcept;

private:
    ITypeInfo*      m_pTypeInfo;
    volatile ULONG  m_lRefCount;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

#endif
