#include "precomp.h"

static volatile ULONG_PTR gs_lLockCount;

BOOL WINAPI DllMain(HINSTANCE hinstDll, DWORD fdwReason, LPVOID)
{
    switch(fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            g_hInst = hinstDll;
            DisableThreadLibraryCalls(g_hInst);
            break;
        default:
            break;
    }

    return(TRUE);
}

ULONG_PTR LockServer()
{
    return(InterlockedIncrement(&gs_lLockCount));
}

ULONG_PTR UnlockServer()
{
    return(InterlockedDecrement(&gs_lLockCount));
}

STDAPI DllCanUnloadNow()
{
    return((gs_lLockCount) ? S_FALSE : S_OK);
}

#pragma warning(push)
#pragma warning(disable: 6387)
__checkReturn STDAPI DllGetClassObject(__in REFCLSID rclsid, __in REFIID riid, __deref_out void** ppvObject)
{
    IClassFactory*  pcf;
    HRESULT         hr;

    if(IsBadWritePtrT(ppvObject))
        return(E_INVALIDARG);

    *ppvObject = nullptr;

    if(IsBadReadPtrT(&rclsid))
        return(E_INVALIDARG);

    if(IsEqualCLSID(rclsid, CLSID_CP210xDevices))
        pcf = new (std::nothrow) CClassFactoryT<CCP210xDevices>;
    else
        return(CLASS_E_CLASSNOTAVAILABLE);

    if(!pcf)
        return(E_OUTOFMEMORY);

    hr = pcf->QueryInterface(riid, ppvObject);
    pcf->Release();
    return(hr);
}
#pragma warning(pop)
