#ifndef MISC_H
#define MISC_H

template<typename T> inline BOOL IsBadWritePtrT(T pt) noexcept
{
#ifndef _DEBUG
    return(!pt);
#else
    return(::IsBadWritePtr(pt, sizeof(*pt)));
#endif
}

template<typename T> inline BOOL IsBadReadPtrT(T pt) noexcept
{
#ifndef _DEBUG
    return(!pt);
#else
    return(::IsBadReadPtr(pt, sizeof(*pt)));
#endif
}

HRESULT StatusToHresult(CP210x_STATUS stat);
HRESULT BSTRFromStringA(const char* pstr, BSTR* pbstr) noexcept;
FORCEINLINE HRESULT BSTRFromStringW(const wchar_t* pstr, BSTR* pbstr) noexcept { return((nullptr != (*pbstr = SysAllocString(pstr))) ? S_OK : E_OUTOFMEMORY); }

#ifdef UNICODE
#define BSTRFromString    BSTRFromStringW
#else
#define BSTRFromString    BSTRFromStringA
#endif

#endif
